VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 1  'Persistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Contains the dimensions of a rectangle in a coordinate system
Public Left As Long     ' X1
Attribute Left.VB_VarDescription = "Returns/sets the left (X-axis) position of this rectangle."
Public Top As Long      ' Y1
Attribute Top.VB_VarDescription = "Returns/sets the upper (Y-axis) position of this rectangle."
Public Right As Long    ' X2
Attribute Right.VB_VarDescription = "Returns/sets the right (X-axis) position of this rectangle."
Public Bottom As Long   ' Y2
Attribute Bottom.VB_VarDescription = "Returns/sets the bottom (Y-axis) position of this rectangle."

Friend Property Get UDT() As RECT

    ' Return the data within this class as a UDT
    With UDT
        .Left = Left
        .Top = Top
        .Right = Right
        .Bottom = Bottom
    End With

End Property

Friend Property Let UDT(vNewValue As RECT)

    ' Sets the content of this class to correspond to the given UDF
    With vNewValue
        Left = .Left
        Top = .Top
        Right = .Right
        Bottom = .Bottom
    End With

End Property

Friend Function Clone() As clsRect

    ' Create a new class
    Set Clone = New clsRect
    
    ' Then, copy the content
    With Clone
        .Left = Left
        .Top = Top
        .Right = Right
        .Bottom = Bottom
    End With

End Function

Private Sub Class_ReadProperties(PropBag As PropertyBag)
    
    ' Use the given property
    With PropBag
        Left = .ReadProperty("Left", 0)
        Top = .ReadProperty("Top", 0)
        Right = .ReadProperty("Right", 0)
        Bottom = .ReadProperty("Bottom", 0)
    End With

End Sub

Private Sub Class_WriteProperties(PropBag As PropertyBag)

    ' Use the given property
    With PropBag
        .WriteProperty "Left", Left, 0
        .WriteProperty "Top", Top, 0
        .WriteProperty "Right", Right, 0
        .WriteProperty "Bottom", Bottom, 0
    End With

End Sub
